/*
 * Copyright (C) 2006 Andre Noll <maan@systemlinux.org>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

/** \file stdout.h the stdout task structure and exported symbols from stdout.c */

/**
 * the task structure used for writing to stdout
 */
struct stdout_task {
	/** pointer to the data buffer */
	char *buf;
	/** the size of \a buf */
	size_t *bufsize;
	/** number of bytes loaded in \a buf */
	size_t *loaded;
	/** pointer to the eof flag of the feeding task */
	int *input_eof;
	/** non-zero if a write error occured */
	int eof;
	/** the task structure */
	struct task task;
	/** whether \p STDOUT_FILENO was included in the write fd set */
	int check_fd;
};

void stdout_pre_select(struct sched *s, struct task *t);
void stdout_post_select(struct sched *s, struct task *t);
void stdout_set_defaults(struct stdout_task *sot);
